# -*- mode: python; coding: utf-8; -*-

from datetime import datetime, timedelta

from django import template
from django.contrib.auth.models import User
from django.template import RequestContext
from django.utils.encoding import smart_unicode
from django.db import settings

register = template.Library()

@register.inclusion_tag('lib/pagination.html',takes_context=True)
def pagination(context, adjacent_pages=5):
    """adjacent_pages is number of links that will be left and right of current page link"""

    page_list = range(
        max(1,context['page'] - adjacent_pages),
        min(context['pages'],context['page'] + adjacent_pages) + 1)
    lower_page = None
    higher_page = None

    if not 1 == context['page']:
        lower_page = context['page'] - 1

    if not 1 in page_list:
        page_list.insert(0,1)
        if not 2 in page_list:
            page_list.insert(1,'.')

    if not context['pages'] == context['page']:
        higher_page = context['page'] + 1

    if not context['pages'] in page_list:
        if not context['pages'] - 1 in page_list:
            page_list.append('.')
        page_list.append(context['pages'])
    get_params = '&'.join(['%s=%s' % (x[0],','.join(x[1])) for x in
        context['request'].GET.iteritems() if not x[0] == 'page'])
    if get_params:
        get_params = '?%s&' % get_params
    else:
        get_params = '?'

    return {
        'get_params': get_params,
        'lower_page': lower_page,
        'higher_page': higher_page,
        'page': context['page'],
        'pages': context['pages'],
        'page_list': page_list}

